from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, String, Int, Float, Boolean

Pygenometracks_V0_1_0 = CommandToolBuilder(tool="pyGenomeTracks", base_command=["pyGenomeTracks"], inputs=[ToolInput(tag="in_tracks", input_type=File(optional=True), prefix="--tracks", doc=InputDocumentation(doc="File containing the instructions to plot the tracks.\nThe tracks.ini file can be genarated using the\n`make_tracks_file` program.")), ToolInput(tag="in_region", input_type=String(optional=True), prefix="--region", doc=InputDocumentation(doc="Region to plot, the format is chr:start-end")), ToolInput(tag="in_bed", input_type=File(optional=True), prefix="--BED", doc=InputDocumentation(doc="Instead of a region, a file containing the regions to\nplot, in BED format, can be given. If this is the\ncase, multiple files will be created using a prefix\nthe value of --outFileName")), ToolInput(tag="in_width", input_type=Int(optional=True), prefix="--width", doc=InputDocumentation(doc="figure width in centimeters (default is 40)")), ToolInput(tag="in_plot_width", input_type=String(optional=True), prefix="--plotWidth", doc=InputDocumentation(doc="width in centimeters of the plotting (central) part")), ToolInput(tag="in_height", input_type=String(optional=True), prefix="--height", doc=InputDocumentation(doc="Figure height in centimeters. If not given, the figure\nheight is computed based on the heights of the tracks.\nIf given, the track height are proportionally scaled\nto match the desired figure height.")), ToolInput(tag="in_title", input_type=String(optional=True), prefix="--title", doc=InputDocumentation(doc="Plot title")), ToolInput(tag="in_out_filename", input_type=File(optional=True), prefix="--outFileName", doc=InputDocumentation(doc="File name to save the image, file prefix in case\nmultiple images are stored")), ToolInput(tag="in_font_size", input_type=Int(optional=True), prefix="--fontSize", doc=InputDocumentation(doc="Font size for the labels of the plot (default is 0.3 *\nfigure width)")), ToolInput(tag="in_dpi", input_type=Int(optional=True), prefix="--dpi", doc=InputDocumentation(doc="Resolution for the image in case the ouput is a raster\ngraphics image (e.g png, jpg) (default is 72)")), ToolInput(tag="in_track_label_fraction", input_type=Float(optional=True), prefix="--trackLabelFraction", doc=InputDocumentation(doc="By default the space dedicated to the track labels is\n0.05 of the plot width. This fraction can be changed\nwith this parameter if needed.")), ToolInput(tag="in_track_label_halign", input_type=String(optional=True), prefix="--trackLabelHAlign", doc=InputDocumentation(doc="By default, the horizontal alignment of the track\nlabels is left. This alignemnt can be changed to right\nor center.")), ToolInput(tag="in_decreasing_x_axis", input_type=Boolean(optional=True), prefix="--decreasingXAxis", doc=InputDocumentation(doc="By default, the x-axis is increasing. Use this option\nif you want to see all tracks with a decreasing\nx-axis."))], outputs=[ToolOutput(tag="out_out_filename", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out_filename", type_hint=File()), doc=OutputDocumentation(doc="File name to save the image, file prefix in case\nmultiple images are stored"))], container="quay.io/biocontainers/pygenometracks:3.6--py_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Pygenometracks_V0_1_0().translate("wdl")

